SystemOrganization addCategory: #'Math-Core'!

Object subclass: #DhbWeightedPoint
	instanceVariableNames: 'xValue yValue weight error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Core'!

!DhbWeightedPoint class methodsFor: 'creation' stamp: 'StephaneDucasse 7/12/2015 10:48'!
point: aPoint
	
	^ self new initialize: aPoint weight: 1! !

!DhbWeightedPoint class methodsFor: 'creation' stamp: 'StephaneDucasse 7/12/2015 10:48'!
point: aNumber count: anInteger
	

	^ self
		point: aNumber @ anInteger
		weight:
			(anInteger > 0
				ifTrue: [ 1 / anInteger ]
				ifFalse: [ 1 ])! !

!DhbWeightedPoint class methodsFor: 'creation' stamp: 'StephaneDucasse 7/12/2015 10:48'!
point: aPoint error: aNumber
	
	^ self new initialize: aPoint error: aNumber! !

!DhbWeightedPoint class methodsFor: 'creation' stamp: 'StephaneDucasse 7/12/2015 10:48'!
point: aPoint weight: aNumber
	
	^ self basicNew initialize: aPoint weight: aNumber! !

!DhbWeightedPoint methodsFor: 'information' stamp: 'StephaneDucasse 7/12/2015 10:47'!
chi2ComparisonContribution: aWeightedPoint

	^ (aWeightedPoint yValue - yValue) squared / (1 / aWeightedPoint weight + (1 / weight))! !

!DhbWeightedPoint methodsFor: 'information' stamp: 'StephaneDucasse 7/12/2015 10:47'!
chi2Contribution: aFunction

	^ (yValue - (aFunction value: xValue)) squared * weight! !

!DhbWeightedPoint methodsFor: 'accessing' stamp: 'StephaneDucasse 7/12/2015 10:47'!
error

	error isNil
		ifTrue: [ error := 1 / weight sqrt ].
	^ error! !

!DhbWeightedPoint methodsFor: 'initialization' stamp: 'StephaneDucasse 7/12/2015 10:47'!
initialize: aPoint error: aNumber

	error := aNumber.
	^ self initialize: aPoint weight: 1 / aNumber squared! !

!DhbWeightedPoint methodsFor: 'initialization' stamp: 'StephaneDucasse 7/12/2015 10:47'!
initialize: aPoint weight: aNumber

	xValue := aPoint x.
	yValue := aPoint y.
	weight := aNumber.
	^ self! !

!DhbWeightedPoint methodsFor: 'accessing' stamp: 'StephaneDucasse 7/12/2015 10:47'!
point

	^ xValue @ yValue! !

!DhbWeightedPoint methodsFor: 'accessing' stamp: 'DanielUber 5/31/2012 12:05:19.968'!
weight
	^weight! !

!DhbWeightedPoint methodsFor: 'accessing' stamp: 'DanielUber 5/31/2012 12:05:19.968'!
xValue
	^xValue! !

!DhbWeightedPoint methodsFor: 'accessing' stamp: 'DanielUber 5/31/2012 12:05:19.968'!
yValue
	^yValue! !
